SystemOrganization addCategory: #'Seaside-Tests-Playground'!

WAComponent subclass: #WAPlaygroundComponent
	instanceVariableNames: 'code callbackValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Playground'!

!WAPlaygroundComponent class methodsFor: 'class initialization' stamp: 'obi 1/2/2010 18:16'!
description
	^ 'Seaside playground'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/2/2010 19:21'!
exampleCode
^'html big: ''TEST Playground''.
html form: [
 html multiSelect list: #(11 12 13 14 15);
   selected: (self get: #list);
   callback: [:v | self set: #list value: v ].
 html break.
 html textInput value: (self get: #input);  callback: [:v | self set: #input value: v].
 html break.
html submitButton value: ''OK'']'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/2/2010 20:39'!
exampleJQCode
^'html anchor
 onClick: ((html jQuery: #itsme) fadeIn: 1 seconds);
 with: ''Show''.
html space: 2.
html anchor
 onClick: ((html jQuery: #itsme) hide: 1 seconds);
 with: ''Hide''.
html div id: ''itsme'';
 style: ''border:1px solid #ccc;width:100px;background:#fee'';
 with: [
  html div: ''I am DIV''.
  html div: ''with some text....'']'! !

!WAPlaygroundComponent class methodsFor: 'class initialization' stamp: 'obi 1/2/2010 18:16'!
handlerName
	^'examples/playground'! !

!WAPlaygroundComponent class methodsFor: 'class initialization' stamp: 'obi 1/2/2010 19:49'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: self handlerName.
	application
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/2/2010 18:20'!
buildCode
	^'[:html | ', code ,']'! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/2/2010 18:51'!
callbackValuesString
	| stream |
	stream := WriteStream on: String new.
	callbackValues keysAndValuesDo: [:k :v |
		stream nextPutAll: k asString, ' -> ', v printString.
		stream cr.].
	^stream contents! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/2/2010 19:12'!
clearCallbackValues
	callbackValues := Dictionary new! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/2/2010 18:22'!
code
	^code! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/2/2010 18:22'!
code: aString
	code := aString! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/2/2010 19:56'!
evaluateWith: html
	
	[(Compiler evaluate: self buildCode for: self logged: false) value: html ] on: Error do: [:ex | html div class: 'error'; with: ex. ex resume]! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/2/2010 18:53'!
get: key 
	^callbackValues at: key ifAbsent: []! !

!WAPlaygroundComponent methodsFor: 'initialization' stamp: 'obi 1/2/2010 18:37'!
initialize
	super initialize.
	code := ''.
	callbackValues := Dictionary new.! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/2/2010 19:21'!
loadExample
	code := self class exampleCode! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/2/2010 19:52'!
loadJQExample
	code := self class exampleJQCode! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/2/2010 19:52'!
renderContentOn: html
	html heading level3; with: 'Seaside playground'.
	html div class: 'code'; 
		with: [ self evaluateWith: html ].
	html form: [
		html table: [
			html tableRow: [html tableHeading: 'Code'; tableHeading: 'Values (usage: set: #list value: value or get: #list)'].
			html tableRow: [
				html tableData: [ html textArea columns: 120; rows: 20; on: #code of: self ].
				html tableData: [ html textArea columns: 40; rows: 20; value: self callbackValuesString] ] ].
		html submitButton value: 'RUN'.
		html space.
		html submitButton value: 'Reset'; callback: [self clearCallbackValues].
		html space.
		html submitButton value: 'Example'; callback: [self loadExample ].
		html space.
		html submitButton value: 'JQ Example'; callback: [self loadJQExample ]
		 ]! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/2/2010 18:31'!
set: key to: value! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/2/2010 18:48'!
set: key value: value
	callbackValues at: key put: value! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/2/2010 19:55'!
style
	^'h3, th  {
color:#FF7200;
font-size:20px;
margin-bottom:6px;}
.error {color:red;font-size:14px;font-family:verdana}
 .code {background:#fff;height:400px;overflow:auto;border:1px solid #ccc;padding:4px;margin:4px}'! !

!WAPlaygroundComponent methodsFor: 'updating' stamp: 'obi 1/2/2010 19:39'!
theme
	^JQBaseTheme default! !

!WAPlaygroundComponent methodsFor: 'updating' stamp: 'obi 1/2/2010 19:38'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	self theme updateRoot: anHtmlRoot.
	JQUiAllTestsLibrary default 
		updateRoot: anHtmlRoot! !
WAPlaygroundComponent initialize!
